//转换页面

var fs = require('fs'),
    path = require('path');
var pageFile = null;
var Wxml = require('./wxml');
var Wxss = require('./wxss');
var chalk = require('chalk');
var debug = require('debug')('wevue');

function readFile(wxFolder, page, rootFolder, ext) {
    var file = path.join(wxFolder, page + ext);
    if (fs.existsSync(file)) {
        return fs.readFileSync(file, 'utf8');
    }
    return null;
}

module.exports = function(wxFolder, vueFolder, page, rootFolder, wevueFolder, program, cb) {
    debug("convert", page);
    var pathInfo = path.parse(page);
    var vue = pathInfo.name;

    var folder = path.parse(pathInfo.dir).name;


    debug('page wevueFolder', wevueFolder);
    pageFile = path.join(wevueFolder, `template${program.ver || ''}`, "page.vue");

    var wxml = readFile(wxFolder, page, rootFolder, '.wxml');
    var wxss = readFile(wxFolder, page, rootFolder, '.wxss') || "";
    var js = readFile(wxFolder, page, rootFolder, '.js');
    var json = readFile(wxFolder, page, rootFolder, '.json') || '{}';
    var cdepJs = readFile(wxFolder, page, rootFolder, '.cdep.js');

    var ddep = readFile(wxFolder, page, rootFolder, '.ddep.js');
    var mdep = readFile(wxFolder, page, rootFolder, '.mdep.js');


    if (!wxml) {
        debug(page + '.wxml不存在');
        cb(null, null);
        return;
    }



    Wxml(wxml, program.close, function(err, xml) {
        var template = fs.readFileSync(pageFile, 'utf8');
        var xml = template.replace('{{XML}}', xml).replace('{{WXSS}}', Wxss(wxss));
        var pageFolder = path.join(vueFolder, 'src', 'pages', folder);
        if (!fs.existsSync(pageFolder)) {
            fs.mkdirSync(pageFolder);
        }

        fs.writeFileSync(path.join(pageFolder, vue + '.vue'), xml);
        if (js) {
            fs.writeFileSync(path.join(pageFolder, vue + '.js'), js);
        }

        if (json) {
            fs.writeFileSync(path.join(pageFolder, vue + '.json'), json);
        }

        if (cdepJs) {
            fs.writeFileSync(path.join(pageFolder, vue + '.cdep.js'), cdepJs);
        }
        if (ddep) {
            fs.writeFileSync(path.join(pageFolder, vue + '.ddep.js'), ddep);
        }
        if (mdep) {
            fs.writeFileSync(path.join(pageFolder, vue + '.cdep.js'), mdep);
        }
        cb(err, null);
    });

}
