var path = require('path')
var lodash = require('lodash')
var fs = require('fs')

var appJsonPath = path.resolve(__dirname, '../src/app.json')
var RegPluginsVueFilePath = path.resolve(__dirname, '../src/layouts/RegPlugins.vue')



var appConf = require(appJsonPath)

var plugins = []

var remoteCss = []

if (appConf.advance) {
    if (appConf.advance.plugins) {
        if (lodash.isArray(appConf.advance.plugins)) {
            plugins = appConf.advance.plugins
        }
    }

    if (appConf.advance.css) {
        if (lodash.isArray(appConf.advance.css)) {
            remoteCss = appConf.advance.css
        }
    }
}

var importLessStr = ''
for (var i in plugins) {
    if (plugins[i].css) {
        importLessStr += `@import "${plugins[i].css}";`
    }
}
for(var i in remoteCss){
    if (remoteCss[i]) {
        importLessStr += `@import "${remoteCss[i]}";`
    }
}

var RegPluginsVueFileContent = fs.readFileSync(RegPluginsVueFilePath, {
    encoding: 'utf8'
})

var regex = /default_import_remote_c.*{[^}]*}/img
RegPluginsVueFileContent = RegPluginsVueFileContent.replace(regex, `default_import_remote_c{${importLessStr}}`)

fs.writeFileSync(RegPluginsVueFilePath, RegPluginsVueFileContent);



/*PC逻辑*/



appJsonAdminPath = path.resolve(__dirname, '../src/app-admin.json')

RegPluginsVueAdminFilePath = path.resolve(__dirname, '../src/layouts/RegPlugins-admin.vue')


appConf = require(appJsonAdminPath)

plugins = []

remoteCss = []

if (appConf.advance) {
    if (appConf.advance.plugins) {
        if (lodash.isArray(appConf.advance.plugins)) {
            plugins = appConf.advance.plugins
        }
    }

    if (appConf.advance.css) {
        if (lodash.isArray(appConf.advance.css)) {
            remoteCss = appConf.advance.css
        }
    }
}

importLessStr = ''
for (var i in plugins) {
    if (plugins[i].css) {
        importLessStr += `@import "${plugins[i].css}";`
    }
}
for(var i in remoteCss){
    if (remoteCss[i]) {
        importLessStr += `@import "${remoteCss[i]}";`
    }
}

RegPluginsVueFileContent = fs.readFileSync(RegPluginsVueAdminFilePath, {
    encoding: 'utf8'
})

regex = /default_import_remote_c.*{[^}]*}/img
RegPluginsVueFileContent = RegPluginsVueFileContent.replace(regex, `default_import_remote_c{${importLessStr}}`)

fs.writeFileSync(RegPluginsVueAdminFilePath, RegPluginsVueFileContent);


//end PC逻辑
