var download = require('download')
var path = require('path')
var lodash = require('lodash')
var fs = require('fs')
var mkdir = fs.mkdir

var getDirName = path.dirname

var appJsonPath = path.resolve(__dirname, '../src/app.json')

var appJsonAdminPath = path.resolve(__dirname, '../src/app-admin.json')


var pluginPath = path.resolve(__dirname, '../src/plugins/')

var appConf = require(appJsonPath)

var appAdminConf = require(appJsonAdminPath)

var plugins = []

if (appConf.advance) {
    if (appConf.advance.plugins) {
        if (lodash.isArray(appConf.advance.plugins)) {
            plugins = lodash.union(plugins,appConf.advance.plugins)
        }
    }
}


if (appAdminConf.advance) {
    if (appAdminConf.advance.plugins) {
        if (lodash.isArray(appAdminConf.advance.plugins)) {
            plugins = lodash.union(plugins,appAdminConf.advance.plugins)
        }
    }
}

plugins.forEach(function(item, index) {
    if(!item.name){
        console.log("第",index+1,"个组件缺少参数name");
        return true;
    }

    if(item.js){
        if(item.js.match(/\/\//)){
            console.log("正在下载...",(item.name||"")+"->",item.js);
            var filePathJs = path.resolve(pluginPath, item.name, 'index.min.js');

            if(fs.existsSync(filePathJs)===false){

                download(item.js).then(dataJs => {
                    console.log("done!");
                    mkdir(getDirName(filePathJs), function(err) {
                        fs.writeFileSync(filePathJs, dataJs);
                    });
                });
            }else{
                console.log("已存在的js",item.name, 'index.min.js');
            }
        }else{
            console.log('引用本地插件资源(JS)');
        }
    }


    if(item.css){
        if(item.css.match(/\/\//)){

            console.log("正在下载...",(item.name||"")+"->",item.css);
            var filePathCss = path.resolve(pluginPath, item.name, 'index.min.css');

            if(fs.existsSync(filePathCss)===false){

                download(item.css).then(dataCss => {
                    console.log("done!");
                    mkdir(getDirName(filePathCss), function(err) {
                        fs.writeFileSync(filePathCss, dataCss);
                    });
                });
            }else{
                console.log("已存在的css",item.name, 'index.min.css');
            }
        }else{
            console.log('引用本地插件资源(CSS)');

        }
    }
})
