
import { appOnLaunch, appOnShow,appOnReady, appOnHide, appOnError } from '../lifecycle'
import {appFilter} from '../filters/app-data-methods-filter.js'

export function defaultAppMixins() {
    require('vueroot/app.js')

    let filterRet = {}
    filterRet = appFilter()
    return {
        methods: {
            getApp() {
                return this
            },
            setData(newVal={}){
                Object.assign(this,newVal)
            },
            $getComponentInstence(){
                let ret = new Object()
                let list = this.$children
                let c1 = list[0]
                let c2 = list[1]
                if(c1.$options._componentTag==="page-progress-bar"){
                    ret = c2
                }else if(c2.$options._componentTag==="page-progress-bar"){
                    ret = c1
                }else{
                    ret = __WEVUE_GI.PVCI[__WEVUE_GI.PAGEPATH]
                }
                return ret
            },
            ...filterRet.methods
        },
        computed:{
            data(){
                return this
            }
        },
        data(){
            return {
                ...filterRet.data
            }
        },
        beforeCreate() {

        },
        created() {
            getApp = this.getApp
            __WEVUE_GI.PVAPP = this
            appOnLaunch.apply(this)
        },
        beforeMount() {

        },
        mounted() {
            getApp = this.getApp
            __WEVUE_GI.PVAPP = this
            appOnShow.apply(this)
            appOnReady.apply(this)
        },
        beforeUpdate() {

        },
        updated() {

        },
        beforeDestroy() {
            appOnHide.apply(this)
        },
        destroyed() {
        },
        ...filterRet.vueAttr
    }
} 