/**
 * @lzq
 * App lifecycle
 */


/**
 * @lzq
 * common functions
 */
function executeFunction(func, ctx=window, arg) {
    /**
     * 执行某个函数
     */
    if (func) {
        if ('function' == typeof func) {
            return func.apply(ctx, arg)
        } else {
            console.error("need a function")
            return false
        }
    }
    return true
}


/**
 * @lzq
 * app.js onLaunch
 */
export function appOnLaunch() {
    executeFunction(__WEVUE_GI.AppXCXOpt.onLaunch,this,arguments)
}

/**
 * @lzq
 * app.js onShow
 */
export function appOnShow() {
    executeFunction(__WEVUE_GI.AppXCXOpt.onShow,this,arguments)
    
}

/**
 * @lzq
 * app.js onReady
 */
export function appOnReady() {
    executeFunction(__WEVUE_GI.AppXCXOpt.onReady,this,arguments)
    
}


/**
 * @lzq
 * app.js onHide
 */
export function appOnHide() {
    executeFunction(__WEVUE_GI.AppXCXOpt.onHide,this,arguments)
}

/**
 * @lzq
 * app.js onError
 */
export function appOnError() {
    executeFunction(__WEVUE_GI.AppXCXOpt.onError,this,arguments)
}




/**
 * @lzq
 * Page.js
 */


/**
 * @lzq
 * page onLoad
 * this -> page.vue ctx
 */
export function pageOnLoad() {
    executeFunction(__WEVUE_GI.PageXCXOpt[__WEVUE_GI.PAGEPATH].onLoad,this,arguments)
}

/**
 * @lzq
 * page onShow
 * this -> page.vue ctx
 */
export function pageOnShow() {
    executeFunction(__WEVUE_GI.PageXCXOpt[__WEVUE_GI.PAGEPATH].onShow,this,arguments)

}

/**
 * @lzq
 * page onReady
 * this -> page.vue ctx
 */
export function pageOnReady() {
    executeFunction(__WEVUE_GI.PageXCXOpt[__WEVUE_GI.PAGEPATH].onReady,this,arguments)


}


/**
 * @lzq
 * page onHide
 * this -> page.vue ctx
 */
export function pageOnHide() {
    executeFunction(__WEVUE_GI.PageXCXOpt[__WEVUE_GI.PAGEPATH].onHide,this,arguments)

}

/**
 * @lzq
 * page onUnload
 * this -> page.vue ctx
 */
export function pageOnUnload() {
    executeFunction(__WEVUE_GI.PageXCXOpt[__WEVUE_GI.PAGEPATH].onUnload,this,arguments)

}


/**
 * @lzq
 * page onPullDownRefresh
 * this -> page.vue ctx
 */
export function pageOnPullDownRefresh() {
    executeFunction(__WEVUE_GI.PageXCXOpt[__WEVUE_GI.PAGEPATH].onPullDownRefresh,this,arguments)

}

/**
 * @lzq
 * page onReachBottom
 * this -> page.vue ctx
 */
export function pageOnReachBottom() {
    executeFunction(__WEVUE_GI.PageXCXOpt[__WEVUE_GI.PAGEPATH].onReachBottom,this,arguments)
}

/**
 * @lzq
 * page onShareAppMessage
 * this -> page.vue ctx
 */
export function pageOnShareAppMessage() {
    executeFunction(__WEVUE_GI.PageXCXOpt[__WEVUE_GI.PAGEPATH].onShareAppMessage,this,arguments)
}



/**
 * @lzq 
 * 额外周期：路由变化之前执行 可以中断路由
 * @params:to 即将要访问的路由
 * @params：from 从哪个路由过来
 * return true|false | path
 */
export function beforeRouteChange(to, from) {
    console.log("beforeRouteChange")

    let handleAppRouterChangeRet = executeFunction(__WEVUE_GI.AppXCXOpt.beforeRouteChange,__WEVUE_GI.PVAPP||{},arguments)
    
    let handlePageRouterChangeRet = null
    if(__WEVUE_GI.PageXCXOpt[__WEVUE_GI.PAGEPATH]){
        handlePageRouterChangeRet = executeFunction(__WEVUE_GI.PageXCXOpt[__WEVUE_GI.PAGEPATH].beforeRouteChange,__WEVUE_GI.PageXCXOpt[__WEVUE_GI.PAGEPATH],arguments)
    }
    
    let ret = true

    if(handlePageRouterChangeRet===false||handlePageRouterChangeRet===true||('string' ==typeof handlePageRouterChangeRet)){
        ret = handlePageRouterChangeRet
    }else if(handleAppRouterChangeRet===false||handleAppRouterChangeRet===true||('string' ==typeof handleAppRouterChangeRet)){
        ret = handleAppRouterChangeRet
    }else{
        ret = true
    }
    return ret
}

/**
 * @lzq 
 * 额外周期：路由变化之后执行 next无效
 * @params:to 即将要访问的路由
 * @params：from 从哪个路由过来
 */
export function afterRouteChange(to, from) {
    executeFunction(__WEVUE_GI.AppXCXOpt.afterRouteChange,__WEVUE_GI.PVAPP||{},arguments)
    if(__WEVUE_GI.PageXCXOpt[__WEVUE_GI.PAGEPATH]){
        executeFunction(__WEVUE_GI.PageXCXOpt[__WEVUE_GI.PAGEPATH].afterRouteChange,__WEVUE_GI.PVCI[__WEVUE_GI.PAGEPATH]||{},arguments)
    }
    
    console.log("afterRouteChange")
}

export const lifecycle = {
    appOnLaunch, appOnShow, appOnHide, appOnError,
    pageOnLoad, pageOnShow, pageOnReady, pageOnHide, pageOnUnload, pageOnPullDownRefresh, pageOnShareAppMessage, pageOnReachBottom,
    beforeRouteChange, afterRouteChange
}